diff --git a/.gitignore b/.gitignore
index cbcaa5c6..ec2d5bb2 100644
--- a/.gitignore
+++ b/.gitignore
@@ -1,4 +1,5 @@
 /.bundle/
+/.bundle-path/
 /vendor/bundle/
 /tmp/
 *.gem
diff --git a/examples/systemd/hive-web.service b/examples/systemd/hive-web.service
new file mode 100644
index 00000000..c2b937c9
--- /dev/null
+++ b/examples/systemd/hive-web.service
@@ -0,0 +1,68 @@
+# Sample systemd-user unit for `hive web` (Linux).
+#
+# This file is installer-managed: `hive web install` rewrites ExecStart=
+# and Environment=PATH= to match the resolved binary + Ruby manager
+# detected on the host, then enables + starts the unit. You normally do
+# not edit this by hand — re-run `hive web install` instead.
+#
+# BEFORE INSTALLING BY HAND: edit ExecStart= to match where YOUR `hive`
+# binary lives. `which hive` shows it. Common paths:
+#
+#   %h/.local/bin/hive                           ← README / install.sh
+#   /usr/local/bin/hive                          ← system gem install
+#   %h/.local/share/mise/shims/hive              ← mise / rbenv / asdf shim
+#
+# Install:
+#   hive web install
+#   # or by hand:
+#   mkdir -p ~/.config/systemd/user
+#   cp examples/systemd/hive-web.service ~/.config/systemd/user/
+#   $EDITOR ~/.config/systemd/user/hive-web.service
+#   systemctl --user daemon-reload
+#   systemctl --user enable --now hive-web
+#
+# Verify:
+#   systemctl --user status hive-web
+#   journalctl --user -u hive-web -n 50
+#   curl -sS http://127.0.0.1:4567/health/deep
+#
+# View logs:
+#   journalctl --user -u hive-web -f
+#
+# Stop / restart:
+#   systemctl --user stop hive-web
+#   systemctl --user restart hive-web
+#
+# To survive logout:
+#   sudo loginctl enable-linger $USER
+#
+# This unit runs the Rails UI in the foreground (`hive web`). systemd is
+# the supervisor; Restart=on-failure brings it back if it crashes.
+# StartLimit* caps the respawn loop so a wrong ExecStart= path stops
+# cleanly with `failed` instead of relaunching forever.
+#
+# hive-web is independent of hive-daemon — they share XDG state and the
+# project registry but are separate service-manager jobs.
+
+[Unit]
+Description=Hive local web UI (Rails)
+After=default.target
+# Hard cap on the auto-restart loop. If `hive web` exits non-zero 3 times
+# within 5 minutes, systemd marks the unit `failed` instead of respawning
+# forever. Safety net for a misconfigured ExecStart= or missing Rails bundle.
+StartLimitBurst=3
+StartLimitIntervalSec=300
+
+[Service]
+Type=simple
+# systemd user services do NOT inherit the interactive shell PATH, so
+# PATH below covers incidental shell-outs and the gem wrapper's
+# `#!/usr/bin/env ruby` shebang. `hive web install` detects
+# mise/rbenv/asdf and prepends the matching shim directory automatically.
+Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+ExecStart=%h/.local/bin/hive web
+Restart=on-failure
+RestartSec=10
+
+[Install]
+WantedBy=default.target
diff --git a/hive.gemspec b/hive.gemspec
index e54a3dec..85b6516c 100644
--- a/hive.gemspec
+++ b/hive.gemspec
@@ -60,6 +60,9 @@ Gem::Specification.new do |spec|
   spec.add_dependency "faraday", ">= 2.14.2", "< 3.0"
   spec.add_dependency "faraday-multipart", "~> 1.0"
   spec.add_dependency "lipgloss", "~> 0.2.2"
+  # Ruby 3.4 no longer ships REXML as a default gem; the launchd unit
+  # parser (daemon binary-drift status) requires it at runtime.
+  spec.add_dependency "rexml", ">= 3.3", "< 4.0"
   spec.add_dependency "sqlite3", "~> 2.0"
   spec.add_dependency "telegram-bot-ruby", "~> 2.7"
   spec.add_dependency "thor", "~> 1.3"
diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0e..4e57ef93 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -30,6 +30,12 @@ module Hive
       "hive-daemon-enroll" => 1,
       "hive-daemon-reload" => 1,
       "hive-daemon-install" => 1,
+      # Local setup and managed Rails lifecycle contracts. These are public
+      # agent-facing envelopes just like the daemon lifecycle family above;
+      # keep their producers and checked-in schemas on the same registry.
+      "hive-setup" => 1,
+      "hive-web-install" => 1,
+      "hive-web-status" => 1,
       # Read-only inspection of the daemon's dispatch-request queue
       # (`hive daemon queue [list|show|prune]`). See AN-1/2/3 and
       # `Hive::Commands::Daemon#queue_command`.
diff --git a/lib/hive/bot/supervisor.rb b/lib/hive/bot/supervisor.rb
index c1d0ad4f..d0710091 100644
--- a/lib/hive/bot/supervisor.rb
+++ b/lib/hive/bot/supervisor.rb
@@ -779,7 +779,9 @@ module Hive
         # the first request and keep the rest as a daemon-promoted
         # continuation. The retry command is not visible to the daemon until
         # `markers clear` exits 0.
-        if commands.all? { |argv| queue_routable?(argv) }
+        if commands.all? do |argv|
+          queue_routable?(argv, project: result.project, slug: result.slug)
+        end
           return enqueue_command_sequence(commands, result, update)
         end
 
@@ -1012,7 +1014,11 @@ module Hive
         # bump the task state-file mtime — the diagnose refresh only
         # writes a diagnostics artifact — so they don't cause the
         # dual-writer bug.
-        if queue_routable?(result.command_argv)
+        if queue_routable?(
+          result.command_argv,
+          project: result.project,
+          slug: result.slug
+        )
           return enqueue_dispatch_request(result, update)
         end
 
@@ -1037,8 +1043,10 @@ module Hive
       # rewrites this kind of dispatch into a request-file write; the
       # daemon picks the request up on its next tick and spawns the
       # child. See plan 2026-05-28-002 for why.
-      def queue_routable?(argv)
-        Hive::Daemon::DispatchRequestQueue.valid_argv?(Array(argv))
+      def queue_routable?(argv, project: nil, slug: nil)
+        Hive::Daemon::DispatchRequestQueue.valid_argv?(
+          Array(argv), project: project, slug: slug
+        )
       end
 
       # Write a dispatch request for `result.command_argv` and log
diff --git a/lib/hive/bounded_subprocess.rb b/lib/hive/bounded_subprocess.rb
new file mode 100644
index 00000000..ba93cad1
--- /dev/null
+++ b/lib/hive/bounded_subprocess.rb
@@ -0,0 +1,99 @@
+# frozen_string_literal: true
+
+require "open3"
+require "timeout"
+
+module Hive
+  # Open3-compatible capture for short-lived probes and installers. Children
+  # start in their own process group so a deadline can terminate the whole
+  # tree, including grandchildren that inherited stdout/stderr pipes.
+  module BoundedSubprocess
+    POLL_INTERVAL = 0.02
+    TERM_GRACE_SECONDS = 0.1
+    KILL_GRACE_SECONDS = 0.2
+
+    class TimeoutError < Timeout::Error
+      attr_reader :stdout, :stderr, :elapsed
+
+      def initialize(stdout:, stderr:, elapsed:)
+        @stdout = stdout.to_s
+        @stderr = stderr.to_s
+        @elapsed = elapsed.to_f
+        super("subprocess timed out after #{format('%.2f', @elapsed)}s")
+      end
+    end
+
+    module_function
+
+    # Mirrors Open3.capture3: an optional environment Hash may be the first
+    # positional argument and spawn options (for example chdir:) are keyword
+    # arguments. pgroup is always forced on because it is the cleanup boundary.
+    def capture3(*command, timeout:, **spawn_options)
+      timeout = Float(timeout)
+      raise ArgumentError, "timeout must be positive" unless timeout.positive?
+
+      started = monotonic_now
+      Open3.popen3(*command, **spawn_options.merge(pgroup: true)) do |stdin, stdout, stderr, wait_thread|
+        stdin.close
+        out_reader = Thread.new { read_stream(stdout) }
+        err_reader = Thread.new { read_stream(stderr) }
+        deadline = started + timeout
+
+        loop do
+          process_done = wait_thread.join(POLL_INTERVAL)
+          if process_done && !out_reader.alive? && !err_reader.alive?
+            return [ out_reader.value, err_reader.value, wait_thread.value ]
+          end
+
+          next if monotonic_now < deadline
+
+          terminate_process_group(wait_thread.pid, wait_thread)
+          elapsed = monotonic_now - started
+          raise TimeoutError.new(
+            stdout: finish_reader(out_reader),
+            stderr: finish_reader(err_reader),
+            elapsed: elapsed
+          )
+        end
+      end
+    end
+
+    def terminate_process_group(pid, wait_thread)
+      signal_group("TERM", pid)
+      sleep TERM_GRACE_SECONDS
+      # Always signal the group after the grace period. The direct child may
+      # have exited on TERM while a descendant kept inherited pipes open.
+      signal_group("KILL", pid)
+      wait_thread.join(KILL_GRACE_SECONDS)
+    end
+    private_class_method :terminate_process_group
+
+    def signal_group(signal, pid)
+      Process.kill(signal, -pid)
+    rescue Errno::ESRCH
+      nil
+    end
+    private_class_method :signal_group
+
+    def read_stream(stream)
+      stream.read.to_s
+    rescue IOError
+      ""
+    end
+    private_class_method :read_stream
+
+    def finish_reader(thread)
+      thread.join(KILL_GRACE_SECONDS)
+      thread.kill if thread.alive?
+      thread.value.to_s
+    rescue StandardError
+      ""
+    end
+    private_class_method :finish_reader
+
+    def monotonic_now
+      Process.clock_gettime(Process::CLOCK_MONOTONIC)
+    end
+    private_class_method :monotonic_now
+  end
+end
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd809068..a3172fbc 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -1332,18 +1332,68 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
-    option :bind, type: :string, desc: "override web.bind"
-    option :port, type: :numeric, desc: "override web.port"
-    def web
-      if options[:json]
+    desc "setup", "Diagnose and provision local Hive (daemon, optional web service, project enrollment)"
+    long_desc <<~DESC
+      Full local setup for Linux/macOS:
+
+        1. Bounded dependency diagnostics (Ruby, git, tmux, gh, agents, Node, qmd, web bundle, SQLite)
+        2. Bootstrap Hive-owned assets (qmd + version-matched Rails web bundle)
+        3. Install/start hive-daemon with the invoking CLI binary
+        4. Initialize or enroll the current repository for automatic dispatch
+        5. With --service: also install/start the separate hive-web service
+
+      Bare `hive setup` leaves web as a foreground `hive web` step.
+      `--no-bootstrap` is diagnose-only (no mutations).
+      `--no-init` skips repository init/enrollment.
+      `--json` always emits a complete phase report; exit is non-zero on any hard failure.
+    DESC
+    option :service, type: :boolean, default: false, desc: "also install/start the managed hive-web service"
+    option :no_bootstrap, type: :boolean, default: false, desc: "diagnose only; do not bootstrap or mutate"
+    option :no_init, type: :boolean, default: false, desc: "skip repository init/enrollment"
+    def setup
+      require "hive/commands/setup"
+      Hive::Commands::Setup.new(
+        project_path: Dir.pwd,
+        service: options[:service],
+        no_bootstrap: options[:no_bootstrap],
+        no_init: options[:no_init],
+        json: options[:json]
+      ).call
+    end
+
+    desc "web [SUBCOMMAND]", "Run the local/hivebox web UI, or manage the hive-web service"
+    long_desc <<~DESC
+      Bare `hive web` boots the Rails control surface in the foreground
+      (default bind 127.0.0.1:4567). Managed lifecycle (separate from
+      hive-daemon):
+
+        install [--force] [--json]   write/register the per-user service unit
+        start                        start the managed hive-web service
+        stop                         stop the managed hive-web service
+        status [--json]              report managed service state
+
+      Local installs resolve the Rails app from HIVEBOX_WEB_APP_DIR, the
+      managed XDG data bundle (`hive setup` / AppBundle), or a source
+      checkout. Docker/hivebox continues to use /app/web via the env override.
+    DESC
+    option :bind, type: :string, desc: "override web.bind (foreground only)"
+    option :port, type: :numeric, desc: "override web.port (foreground only)"
+    option :force, type: :boolean, default: false, desc: "overwrite a drifted unit on install"
+    option :unsafe, type: :boolean, default: false,
+                    desc: "allow non-loopback bind without web.github.owner (foreground only)"
+    def web(subcommand = nil)
+      require "hive/commands/web"
+
+      if options[:json] && (subcommand.nil? || subcommand.empty? ||
+                            !Hive::Commands::Web::JSON_ALLOWED.include?(subcommand))
         require "json"
-        message = "hive web has no JSON output (it runs a long-lived server). " \
-                  "Use 'hive status --json' for machine-readable task data."
-        # Mirror `hive tui`'s rejection: emit a structured error envelope (sans
-        # `schema`, since web has no registered hive-* schema) and raise
-        # InvalidTaskPath for the USAGE (64) exit code — parity with every
-        # other --json failure on this surface.
+        message =
+          if subcommand.nil? || subcommand.empty?
+            "hive web has no JSON output (it runs a long-lived server). " \
+              "Use 'hive web status --json' or 'hive status --json'."
+          else
+            "hive web #{subcommand}: --json is only supported for install and status"
+          end
         puts JSON.generate(
           "ok" => false,
           "error_class" => "InvalidTaskPath",
@@ -1354,8 +1404,14 @@ module Hive
         raise Hive::InvalidTaskPath, message
       end
 
-      require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      Hive::Commands::Web.new(
+        subcommand: subcommand,
+        bind: options[:bind],
+        port: options[:port],
+        force: options[:force],
+        json: options[:json],
+        unsafe: options[:unsafe]
+      ).call
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/daemon.rb b/lib/hive/commands/daemon.rb
index 6c91610b..dda9502c 100644
--- a/lib/hive/commands/daemon.rb
+++ b/lib/hive/commands/daemon.rb
@@ -60,7 +60,8 @@ module Hive
       def initialize(subcommand, target = nil, detach: false, dry_run: false,
                      all: false, json: false, force: false,
                      queue_args: [],
-                     hive_home: Hive::Paths.state_home)
+                     hive_home: Hive::Paths.state_home,
+                     emit: true)
         @subcommand = subcommand
         @target = target
         @detach = detach
@@ -70,6 +71,9 @@ module Hive
         @force = force
         @queue_args = Array(queue_args)
         @hive_home = hive_home
+        # Setup and other orchestrators need the mutation/result semantics
+        # without a nested command writing a second stdout document.
+        @emit = emit
       end
 
       def call
@@ -101,6 +105,17 @@ module Hive
 
       private
 
+      # Explicit non-emitting programmatic seam. Unqualified `puts`/`warn`
+      # throughout this command route here; normal CLI construction preserves
+      # the historical global streams, while orchestrators pass `emit: false`.
+      def puts(*lines)
+        $stdout.puts(*lines) if @emit
+      end
+
+      def warn(*lines)
+        $stderr.puts(*lines) if @emit
+      end
+
       def start_daemon
         warn_unsupported_json_flag if @json
         FileUtils.mkdir_p(@hive_home)
@@ -182,6 +197,10 @@ module Hive
         )
         supervisor = Hive::Daemon::ChildSupervisor.new(
           dry_run: @dry_run,
+          maintenance_binary_resolver: lambda {
+            require "hive/commands/daemon/service_installer"
+            Hive::Commands::Daemon::ServiceInstaller.new.resolved_binary_for_status
+          },
           default_timeout_sec: daemon_cfg.fetch(
             "child_timeout_sec", Hive::Config::DEFAULTS.dig("daemon", "child_timeout_sec")
           ),
@@ -355,6 +374,7 @@ module Hive
       end
 
       def status_daemon
+        require "hive/daemon/status_report"
         running = false
         pid = nil
         uptime_sec = nil
@@ -369,27 +389,25 @@ module Hive
           end
         end
 
+        report = Hive::Daemon::StatusReport.new(
+          hive_home: @hive_home,
+          binary_path: current_binary_path,
+          running_state: [ running, pid, uptime_sec ]
+        ).to_h
+
         if @json
-          service_state = probe_service_state
-          puts JSON.generate(
-            "schema" => "hive-daemon-status",
-            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
-            "ok" => true,
-            "running" => running,
-            "pid" => running ? pid : nil,
-            "uptime_sec" => uptime_sec,
-            "pid_file" => pid_file,
-            "log_file" => log_file,
-            "service_installed" => service_state["service_installed"],
-            "service_enabled" => service_state["service_enabled"],
-            "unit_path" => service_state["unit_path"],
-            # Agent-native parity with the TUI footer / bot push: expose the
-            # update nudge so a programmatic caller can detect "behind" too.
-            "current_version" => Hive::VERSION,
-            "update_nudge" => update_nudge_payload
-          )
+          puts JSON.generate(report)
         elsif running
           puts "hive daemon: running (pid #{pid}, uptime #{uptime_sec}s)"
+          drift = report["binary_drift"]
+          unless drift == "none" || drift == "not_applicable"
+            puts "hive daemon: binary drift: #{drift}" \
+                 " (installed=#{report['installed_binary'].inspect}" \
+                 " expected=#{report['expected_binary'].inspect}" \
+                 " installed_version=#{report['installed_version'].inspect}" \
+                 " current_version=#{report['current_version'].inspect})"
+            puts "hive daemon: repair with `hive daemon install --force`"
+          end
         else
           puts "hive daemon: not running"
         end
@@ -397,29 +415,6 @@ module Hive
         raise Hive::Error, "daemon not running" unless running
       end
 
-      # Read-only autostart-state snapshot for the status envelope. A status
-      # probe must never take down the running/pid reporting that precedes
-      # it, so any failure degrades the three service fields to null (the
-      # status schema marks them required-but-nullable) instead of raising
-      # out of the whole command.
-      def probe_service_state
-        require "hive/commands/daemon/service_installer"
-        Hive::Commands::Daemon::ServiceInstaller.new.service_state
-      rescue StandardError
-        { "service_installed" => nil, "service_enabled" => nil, "unit_path" => nil }
-      end
-
-      # The daemon-written update nudge, as a plain Hash for the status
-      # envelope (nil when current or unknown). Never raises out of status.
-      def update_nudge_payload
-        nudge = Hive::UpdateCheck::State.new.nudge
-        return nil unless nudge
-
-        { "latest" => nudge.latest, "channel" => nudge.channel, "command" => nudge.command }
-      rescue StandardError
-        nil
-      end
-
       def reload_daemon
         result = compute_reload_outcome
         if @json
diff --git a/lib/hive/commands/daemon/queue_command.rb b/lib/hive/commands/daemon/queue_command.rb
index 66c041b9..7cb9b385 100644
--- a/lib/hive/commands/daemon/queue_command.rb
+++ b/lib/hive/commands/daemon/queue_command.rb
@@ -163,7 +163,9 @@ module Hive
             "chat_id" => req.chat_id,
             "update_id" => req.update_id,
             "expired" => Hive::Daemon::DispatchRequestQueue.expired?(req),
-            "allowlisted" => Hive::Daemon::DispatchRequestQueue.valid_argv?(req.argv)
+            "allowlisted" => Hive::Daemon::DispatchRequestQueue.valid_argv?(
+              req.argv, project: req.project, slug: req.slug
+            )
           }
         end
 
@@ -185,7 +187,9 @@ module Hive
           requests.each do |req|
             flags = []
             flags << "EXPIRED" if Hive::Daemon::DispatchRequestQueue.expired?(req)
-            flags << "NOT-ALLOWLISTED" unless Hive::Daemon::DispatchRequestQueue.valid_argv?(req.argv)
+            flags << "NOT-ALLOWLISTED" unless Hive::Daemon::DispatchRequestQueue.valid_argv?(
+              req.argv, project: req.project, slug: req.slug
+            )
             suffix = flags.empty? ? "" : " [#{flags.join(' ')}]"
             puts "#{req.request_id}  #{(Time.now - req.created_at).to_i}s  " \
                  "#{req.project}/#{req.slug}  #{req.argv[1]}#{suffix}"
@@ -205,7 +209,9 @@ module Hive
           puts "chat_id:    #{req.chat_id.inspect}"
           puts "update_id:  #{req.update_id.inspect}"
           puts "expired:    #{Hive::Daemon::DispatchRequestQueue.expired?(req)}"
-          puts "allowlisted:#{Hive::Daemon::DispatchRequestQueue.valid_argv?(req.argv)}"
+          puts "allowlisted:#{Hive::Daemon::DispatchRequestQueue.valid_argv?(
+            req.argv, project: req.project, slug: req.slug
+          )}"
         end
       end
     end
diff --git a/lib/hive/commands/init.rb b/lib/hive/commands/init.rb
index 7a13eb00..94c3e3c9 100644
--- a/lib/hive/commands/init.rb
+++ b/lib/hive/commands/init.rb
@@ -75,14 +75,19 @@ module Hive
       CUSTOM_WORKFLOW_HINT_MESSAGE = "custom workflows live in this project — author one with `#{CUSTOM_WORKFLOW_HINT_COMMAND}`".freeze
 
       def initialize(project_path, force: false, json: false, prompts: nil,
-                     workflow: nil, new_workflow: nil, workflow_input: $stdin, workflow_output: $stderr)
+                     workflow: nil, new_workflow: nil, workflow_input: $stdin, workflow_output: $stderr,
+                     emit: true)
         @project_path = File.expand_path(project_path)
         @force = force
         @json = json
         @workflow_name = workflow
         @new_workflow = new_workflow
         @workflow_input = workflow_input
-        @workflow_output = workflow_output
+        # Programmatic callers such as `hive setup` compose Init's result into
+        # their own report. They can disable every Init-owned stdout/stderr
+        # emission without redirecting process-global streams.
+        @emit = emit
+        @workflow_output = @emit ? workflow_output : StringIO.new
         # Optional Prompts instance for testability. Tests inject a
         # pre-fed StringIO-backed instance to drive the interactive flow
         # without touching $stdin. Production keeps this nil so the
@@ -151,7 +156,7 @@ module Hive
         # collect_prompt_answers' contract: USAGE (64), not a generic
         # InternalError crash, and zero disk state (the prompt is BEFORE any
         # writes, per ADR-023).
-        warn "hive: aborted (#{e.message}); no changes made"
+        write_warn("hive: aborted (#{e.message}); no changes made")
         exit Hive::ExitCodes::USAGE
       rescue Hive::Error
         raise
@@ -279,6 +284,8 @@ module Hive
       end
 
       def write_existing_summary(_ops, workflow_choice:, scaffold_paths: nil)
+        return unless @emit
+
         name = File.basename(@project_path)
         $stdout.puts "hive: already initialized #{name}"
         $stdout.puts "workflow: #{workflow_choice.descriptor.id}"
@@ -297,6 +304,8 @@ module Hive
       # of the re-bind. Emit a minimal `already_initialized` hive-init payload
       # (a distinct oneOf arm from the fresh SuccessPayload in the schema).
       def emit_existing_json_summary(ops, workflow_choice:, extra: {})
+        return unless @emit
+
         puts JSON.generate(existing_payload(ops, workflow_choice: workflow_choice).merge(extra))
       rescue Errno::EPIPE
         nil
@@ -733,7 +742,9 @@ module Hive
       end
 
       def write_warn(line)
-        warn line
+        return unless @emit
+
+        $stderr.puts line
       rescue Errno::EPIPE
         nil
       end
@@ -777,6 +788,8 @@ module Hive
       end
 
       def emit_json_summary(entry:, ops:, answers:, workflow:, extra: {})
+        return unless @emit
+
         puts JSON.generate(success_payload(entry: entry, ops: ops, answers: answers, workflow: workflow).merge(extra))
       rescue Errno::EPIPE
         nil
@@ -867,6 +880,8 @@ module Hive
       end
 
       def print_summary(entry:, ops:, answers:, workflow: nil, scaffold_paths: nil)
+        return unless @emit
+
         c = Palette.for($stdout)
         name = entry["name"]
         rows = [
@@ -905,22 +920,27 @@ module Hive
       end
 
       def collect_prompt_answers
-        summary_io = @json ? StringIO.new : $stdout
-        prompts = @prompts || Hive::Commands::Init::Prompts.new(input: $stdin, output: $stderr, summary_io: summary_io)
+        summary_io = (@json || !@emit) ? StringIO.new : $stdout
+        prompt_output = @emit ? $stderr : StringIO.new
+        prompts = @prompts || Hive::Commands::Init::Prompts.new(
+          input: $stdin,
+          output: prompt_output,
+          summary_io: summary_io
+        )
         prompts.collect
       rescue Hive::Commands::Init::Prompts::Aborted => e
         # Distinct exit code (USAGE / 64) from generic crashes (GENERIC / 1)
         # so a scripted agent can tell "user explicitly declined" from
         # "init crashed transiently" and decide whether to retry. Closes
         # ce-code-review F6.
-        warn "hive: aborted (#{e.message}); no changes made"
+        write_warn("hive: aborted (#{e.message}); no changes made")
         exit Hive::ExitCodes::USAGE
       end
 
       def validate_git_repo!
         out, _err, status = Open3.capture3("git", "-C", @project_path, "rev-parse", "--git-common-dir")
         unless status.success?
-          warn "hive: not a git repository: #{@project_path}"
+          write_warn("hive: not a git repository: #{@project_path}")
           exit 1
         end
 
@@ -928,7 +948,7 @@ module Hive
         expected = File.join(@project_path, ".git")
         return if File.expand_path(common) == File.expand_path(expected)
 
-        warn "hive: target appears to be inside a worktree (common dir #{common}); init must run on the main checkout"
+        write_warn("hive: target appears to be inside a worktree (common dir #{common}); init must run on the main checkout")
         exit 1
       end
 
@@ -941,7 +961,7 @@ module Hive
         modified = out.lines.reject { |l| l.start_with?("??") }
         return if modified.empty?
 
-        warn "hive: uncommitted modifications to tracked files; commit or pass --force"
+        write_warn("hive: uncommitted modifications to tracked files; commit or pass --force")
         exit 1
       end
 
diff --git a/lib/hive/commands/service_installer/base.rb b/lib/hive/commands/service_installer/base.rb
index 04f9ba76..b87218aa 100644
--- a/lib/hive/commands/service_installer/base.rb
+++ b/lib/hive/commands/service_installer/base.rb
@@ -81,6 +81,35 @@ module Hive
           }
         end
 
+        # Expected binary path that install! would write into the unit.
+        # Public so StatusReport can compare without re-resolving PATH.
+        def resolved_binary_for_status
+          resolved_binary
+        end
+
+        # Parse the effective hive executable from the installed unit file.
+        # Returns nil when the unit is missing or the path cannot be parsed.
+        # Sets #binary_parse_error on parse failures.
+        attr_reader :binary_parse_error
+
+        def installed_binary_path
+          @binary_parse_error = nil
+          path = target_path
+          return nil if path.nil? || !File.exist?(path)
+
+          body = File.read(path)
+          case platform
+          when :linux then parse_systemd_exec_binary(body)
+          when :macos then parse_launchd_program_binary(body)
+          else
+            @binary_parse_error = "unsupported platform"
+            nil
+          end
+        rescue SystemCallError => e
+          @binary_parse_error = "unreadable: #{e.class}: #{e.message}"
+          nil
+        end
+
         # launchd plist Label for this service. Matches the `<key>Label</key>`
         # value in the bundled plists (local.hive-daemon / local.hive-bot).
         def launchd_label
@@ -404,6 +433,66 @@ module Hive
 
           !!which("launchctl")
         end
+
+        # systemd: `ExecStart=/path/to/hive daemon start` (possibly
+        # Shellwords-escaped). Extract the first token after ExecStart=.
+        def parse_systemd_exec_binary(body)
+          line = body.each_line.find { |l| l.start_with?("ExecStart=") }
+          unless line
+            @binary_parse_error = "no ExecStart= line"
+            return nil
+          end
+
+          value = line.sub(/\AExecStart=/, "").strip
+          # Drop systemd prefix modifiers like `@` / `-` if ever present.
+          value = value.sub(/\A[@+\-!:]+/, "")
+          tokens = Shellwords.split(value)
+          binary = tokens.first
+          if binary.nil? || binary.empty?
+            @binary_parse_error = "empty ExecStart binary"
+            return nil
+          end
+
+          binary
+        rescue ArgumentError => e
+          @binary_parse_error = "unparseable ExecStart: #{e.message}"
+          nil
+        end
+
+        # launchd: ProgramArguments array is
+        #   /bin/sh, -c, precheck, <hive-binary>, daemon|web|bot, ...
+        # The hive binary is the first absolute path that is not /bin/sh.
+        def parse_launchd_program_binary(body)
+          require "rexml/document"
+          doc = REXML::Document.new(body)
+          strings = []
+          doc.elements.each("//key") do |key|
+            next unless key.text.to_s.strip == "ProgramArguments"
+
+            array = key.next_element
+            next unless array && array.name == "array"
+
+            array.elements.each("string") { |s| strings << s.text.to_s }
+            break
+          end
+          if strings.empty?
+            @binary_parse_error = "no ProgramArguments"
+            return nil
+          end
+
+          # Precheck wrapper: /bin/sh -c '...' <binary> <subcommand>...
+          binary = strings.find { |s| s != "/bin/sh" && s != "-c" && s.include?("/") && !s.include?(" ") }
+          binary ||= strings.find { |s| File::SEPARATOR && s.start_with?("/") && s != "/bin/sh" }
+          if binary.nil?
+            @binary_parse_error = "could not locate hive binary in ProgramArguments"
+            return nil
+          end
+
+          binary
+        rescue REXML::ParseException, StandardError => e
+          @binary_parse_error = "unparseable plist: #{e.class}: #{e.message}"
+          nil
+        end
       end
     end
   end
